// SampleConnexionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SampleConnexion.h"
#include "SampleConnexionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Global Variable
int TargetSelection;
//Prototypage of all light extraputty functions
typedef int (*Function_extraputty_Connexion) (char *,char *,char *,bool,long,long);
typedef int (*Function_extraputty_SendRcvCmd) (char *,char *,char *,char *,long,char *,long,unsigned long);
typedef int (*Function_extraputty_WaitingMessage) (char *,char *,char *,char *,long);
typedef int (*Function_extraputty_CloseAll) ();
typedef int (*Function_extraputty_Close) (char *);

Function_extraputty_Connexion Connexion;
Function_extraputty_SendRcvCmd SendRcvCmd;
Function_extraputty_WaitingMessage WaitingMessage;
Function_extraputty_CloseAll CloseAll;
Function_extraputty_Close CloseConnexion;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSampleConnexionDlg dialog

CSampleConnexionDlg::CSampleConnexionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSampleConnexionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSampleConnexionDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSampleConnexionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSampleConnexionDlg)
	DDX_Control(pDX, IDC_WAITING, m_wait);
	DDX_Control(pDX, IDC_LISTTARGET, m_liste);
	DDX_Control(pDX, IDC_CMD, m_cmd);
	DDX_Control(pDX, IDC_CLOSEALL, m_closeall);
	DDX_Control(pDX, IDC_CLOSE, m_close);
	DDX_Control(pDX, IDC_SENDCMD, m_send);
	DDX_Control(pDX, IDC_CONNEXION, m_connexion);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSampleConnexionDlg, CDialog)
	//{{AFX_MSG_MAP(CSampleConnexionDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNEXION, OnConnexion)
	ON_BN_CLICKED(IDC_SENDCMD, OnSendcmd)
	ON_BN_CLICKED(IDC_CLOSEALL, OnCloseall)
	ON_BN_CLICKED(IDC_CLOSE, OnClose)	
	ON_BN_CLICKED(IDC_WAITING, OnWaiting)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSampleConnexionDlg message handlers

BOOL CSampleConnexionDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.
     char TestMessage[2000];
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	//Load ExtraPuTTY DLL
    HMODULE hDLL = LoadLibrary("c:\\ExtraPuTTY.dll");
	if(!hDLL)	//if load failed
	{
		//Display error message
		MessageBox("Impossible to load DLL...", "Erreur", MB_ICONERROR);
		CDialog::OnOK();
	}
	else
	{
       //Link on all functions
       Connexion      = (Function_extraputty_Connexion) GetProcAddress(hDLL, "Connexion");
       SendRcvCmd     = (Function_extraputty_SendRcvCmd) GetProcAddress(hDLL, "SendRcvData");
	   WaitingMessage = (Function_extraputty_WaitingMessage) GetProcAddress(hDLL, "WaitingMessage");
       CloseAll       = (Function_extraputty_CloseAll) GetProcAddress(hDLL, "CloseAllConnexion");
       CloseConnexion = (Function_extraputty_Close) GetProcAddress(hDLL, "CloseConnexion");
	   //Add target in combobox
	   m_liste.AddString("Telnet target : bbs.iscabbs.com");	   
	   m_liste.AddString("ssh target : insecure.org");
	   m_liste.AddString("Telnet putty session : telnet_test ");
	   m_liste.AddString("ssh putty session : ssh_test ");	   	   	   
	   //Select the first Target
	   m_liste.SetCurSel(0);
	   strcpy(TestMessage,"Welcome to Extraputty Connexion Sample.\n");
	   strcat(TestMessage,"With this sample we'll connect this application "); 
	   strcat(TestMessage,"via Telnet and SSH protocol to a distant target for send and received data\n\n");
	   strcat(TestMessage,"We'll can connect the target through 2 ways :\n");
	   strcat(TestMessage," - With default setting of Putty\n");
	   strcat(TestMessage," - With Putty session and your personnal settings\n");
       strcat(TestMessage," (If you want to realised the connexion with the Putty session you must create and saved");
	   strcat(TestMessage," telnet_test and ssh_test session)\n\n");
	   strcat(TestMessage," Information on the Telnet serveur used in this sample :\n");
	   strcat(TestMessage,"    - When the putty terminal will be display, the login send and the message \"Hit return to continue\" display,\n");
	   strcat(TestMessage,"      press  the entrer key on putty terminal\n");
	   strcat(TestMessage,"    - Used the application to send command \"read\"\n");       
	   MessageBox(TestMessage,"Extraputty Connexion Sample",MB_OK);
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSampleConnexionDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSampleConnexionDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSampleConnexionDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//The function "Connexion" is used to made an connexion to target via 
//Telnet or SSH protocol in this example
//But you can change to made n connexion with Rlogin or Raw protocol
//Prototypage of the extraputty fonction 
//int Connexion(char *TargetName,     => TargetName or PuttySession Name (in this case Protocol must be equalt to 4)
//              char *Login,          => Login    (optinonal parameter)
//              char *Password,       => Password (optinonal parameter) 
//              bool ShowPuTTY,       => TRUE: Putty Terminal is display, FALSE: not display
//              long Protocol,        => 0:Telnet,1:SSH,2:Rlogin,3:Raw,4:LoadPutty Session
//              long GenerateReport   => 1:extraputty report activate,0:Not activate
//             );
//For more details of this function go to http://www.extraputty.com/htmldoc/Chapter6.html#LCONECT
void CSampleConnexionDlg::OnConnexion() 
{
	// TODO: Add your control notification handler code here		
	int inc = 0;
	
	//Get selection
	inc = m_liste.GetCurSel();

	if((inc == 0) && (Connexion("bbs.iscabbs.com","Guest","",true,0,1) == 0))
	{
	   m_connexion.EnableWindow(FALSE);
	   m_liste.EnableWindow(FALSE);
	   m_send.EnableWindow(TRUE);
	   m_wait.EnableWindow(TRUE);
	   m_close.EnableWindow(TRUE);
	   m_closeall.EnableWindow(TRUE);
	   m_cmd.EnableWindow(TRUE);
	   //Add your code
	   TargetSelection = inc;
	}
	else if((inc == 1) && (Connexion("insecure.org","root","",true,1,1) == 0))
	{
	   m_connexion.EnableWindow(FALSE);
	   m_liste.EnableWindow(FALSE);
	   m_send.EnableWindow(TRUE);
	   m_wait.EnableWindow(TRUE);
	   m_close.EnableWindow(TRUE);
	   m_closeall.EnableWindow(TRUE);
	   m_cmd.EnableWindow(TRUE);
	   //Add your code
	   TargetSelection = inc;
	}
	else if((inc == 2) && (Connexion("telnet_test","Guest","",true,4,1) == 0))
	{
	   m_connexion.EnableWindow(FALSE);
	   m_liste.EnableWindow(FALSE);
	   m_send.EnableWindow(TRUE);
	   m_wait.EnableWindow(TRUE);
	   m_close.EnableWindow(TRUE);
	   m_closeall.EnableWindow(TRUE);
	   m_cmd.EnableWindow(TRUE);
	   //Add your code
	   TargetSelection = inc;
	}
	else if((inc == 3) && (Connexion("ssh_test","root","root",true,4,1) == 0))
	{
	   m_connexion.EnableWindow(FALSE);
	   m_liste.EnableWindow(FALSE);
	   m_send.EnableWindow(TRUE);
	   m_wait.EnableWindow(TRUE);
	   m_close.EnableWindow(TRUE);
	   m_closeall.EnableWindow(TRUE);
	   m_cmd.EnableWindow(TRUE);
	   //Add your code
	   TargetSelection = inc;
	}
	else
	{
		MessageBox("Failed to made the connexion","ERROR",MB_OK);
	}
}

//The function "SendRcvData" is used to Send and received data  
//If you don't want to received the reply of your command set the parameter TimeCapture to 0
//But you can change to made n connexion with Rlogin or Raw protocol
//Prototypage of the extraputty fonction 
//int SendRcvData(char *TargetName,   => The same TargetName or PuttySession Name used with connexion function
//                char *Command,      => Data to send
//                char *Title,        => Title of your command,used only if extraputty report is activate
//                char *Comments,     => Comments of your command,used only if extraputty report is activate
//                long TimeCapture,   => Time to capture the reply data in ms
//                char *RcvTelnetData => Buffer which contain your data if TimerCapture is > 0
//                );
//For more details of this function go to http://www.extraputty.com/htmldoc/Chapter6.html#LSEND
void CSampleConnexionDlg::OnSendcmd() 
{	
	// TODO: Add your control notification handler code here
	char RcvTelnetData[10024] = "\0";
	char Cmd[205] = "\0";

    GetDlgItemText(IDC_CMD,Cmd,200);
	if(strlen(Cmd) == 0)
	{
       SetDlgItemText(IDC_RCVDATA,"Command is not set");
       return;
	}

	if((TargetSelection == 0) && (SendRcvCmd("bbs.iscabbs.com",Cmd,"TEST_\\TELNET","MFC Test \\1",1000,&RcvTelnetData[0],sizeof(RcvTelnetData),0) == 0))
	{
		if(strlen(RcvTelnetData) == 0)
		{
		  SetDlgItemText(IDC_RCVDATA,"NO DATA RECEIVED !");
		}
		else
		{
          SetDlgItemText(IDC_RCVDATA,RcvTelnetData);
		}
	}
	else if((TargetSelection == 1) && (SendRcvCmd("insecure.org",Cmd,"TEST_SSH","MFC Test 1",5000,&RcvTelnetData[0],sizeof(RcvTelnetData),0) == 0))
	{
		if(strlen(RcvTelnetData) == 0)
		{
		  SetDlgItemText(IDC_RCVDATA,"NO DATA RECEIVED !");
		}
		else
		{
          SetDlgItemText(IDC_RCVDATA,RcvTelnetData);
		}
	}
	else if((TargetSelection == 2) && (SendRcvCmd("telnet_test",Cmd,"TEST_TELNET","MFC Test 1",1000,&RcvTelnetData[0],sizeof(RcvTelnetData),0) == 0))	
	{
		if(strlen(RcvTelnetData) == 0)
		{
		  SetDlgItemText(IDC_RCVDATA,"NO DATA RECEIVED !");
		}
		else
		{
          SetDlgItemText(IDC_RCVDATA,RcvTelnetData);
		}
	}

	else if((TargetSelection == 3) && (SendRcvCmd("ssh_test",Cmd,"TEST_SSH","MFC Test 1",5000,&RcvTelnetData[0],sizeof(RcvTelnetData),0) == 0))	
	{
		if(strlen(RcvTelnetData) == 0)
		{
		  SetDlgItemText(IDC_RCVDATA,"NO DATA RECEIVED !");
		}
		else
		{
          SetDlgItemText(IDC_RCVDATA,RcvTelnetData);
		}
	}
	else
	{
        SetDlgItemText(IDC_RCVDATA,"ERROR");
	}
}

//The function "CloseAllConnexion" is used to close all connexion which is made with the same load of DLL  
//Prototypage of the extraputty fonction 
//int CloseAllConnexion();
//For more details of this function go to http://www.extraputty.com/htmldoc/Chapter6.html#LCLOSEALL
void CSampleConnexionDlg::OnCloseall() 
{
	// TODO: Add your control notification handler code here
	m_connexion.EnableWindow(TRUE);
	m_liste.EnableWindow(TRUE);
	m_send.EnableWindow(FALSE);
	m_wait.EnableWindow(FALSE);
	m_close.EnableWindow(FALSE);
	m_closeall.EnableWindow(FALSE);
	m_cmd.EnableWindow(FALSE);
	CloseAll();
	SetDlgItemText(IDC_RCVDATA,"Close all connexions");
}

//This function is used to close all connexion which is made with the same load of DLL  
//Prototypage of the extraputty fonction 
//int CloseConnexion(char *TargetName  => The same TargetName or PuttySession Name used with connexion function
//                  );
//For more details of this function go to http://www.extraputty.com/htmldoc/Chapter6.html#LCLOSE

void CSampleConnexionDlg::OnClose() 
{
	MessageBox("close","hhh",MB_OK);
	// TODO: Add your control notification handler code here
	m_connexion.EnableWindow(TRUE);
	m_liste.EnableWindow(TRUE);
	m_send.EnableWindow(FALSE);
	m_wait.EnableWindow(FALSE);
	m_close.EnableWindow(FALSE);
	m_closeall.EnableWindow(FALSE);	
	m_cmd.EnableWindow(FALSE);
	//Close connexion
	if((TargetSelection == 0) && (CloseConnexion("bbs.iscabbs.com")==0))
	{
		SetDlgItemText(IDC_RCVDATA,"Sucess to close connexion with bbs.iscabbs.com");
	}
	else if((TargetSelection == 1) && (CloseConnexion("insecure.org")==0))
	{
		SetDlgItemText(IDC_RCVDATA,"Sucess to close connexion with insecure.org");
	}
	else if((TargetSelection == 2) && (CloseConnexion("telnet_test")==0))
	{
		SetDlgItemText(IDC_RCVDATA,"Sucess to close connexion with telnet_test putty session");
	}
	else if((TargetSelection == 3) && (CloseConnexion("ssh_test")==0))
	{
		SetDlgItemText(IDC_RCVDATA,"Sucess to close connexion with ssh_test putty session");
	}
	else
	{
        SetDlgItemText(IDC_RCVDATA,"Error to close connexion");
	}
}

void CSampleConnexionDlg::OnWaiting() 
{
	// TODO: Add your control notification handler code here
	char Cmd[205] = "\0";

    GetDlgItemText(IDC_CMD,Cmd,200);
	if(strlen(Cmd) == 0)
	{
       SetDlgItemText(IDC_RCVDATA,"Message is not set");
       return;
	}
	
	if((TargetSelection == 0) && (WaitingMessage("bbs.iscabbs.com",Cmd,"TEST_\\TELNET","MFC Test \\1",1000) == 0))
	{
		SetDlgItemText(IDC_RCVDATA,"Message received on terminal");
	}	
	else if((TargetSelection == 1) && (WaitingMessage("insecure.org",Cmd,"TEST_SSH","MFC Test 1",5000) == 0))
	{
		SetDlgItemText(IDC_RCVDATA,"Message received on terminal");
	}	
	else if((TargetSelection == 2) && (WaitingMessage("telnet_test",Cmd," ","MFCTest1",20000) == 0))
	{
	    SetDlgItemText(IDC_RCVDATA,"Message received on terminal");
	}	
	else if((TargetSelection == 3) && (WaitingMessage("ssh_test",Cmd,"TEST_SSH","MFC Test 1",5000) == 0))
	{
		SetDlgItemText(IDC_RCVDATA,"Message received on terminal");
	}
	else
	{
        SetDlgItemText(IDC_RCVDATA,"ERROR");
	}
}
